% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fastrInteropt.R
\name{is.external.array}
\alias{is.external.array}
\title{Determines whether the given external object has a size. If an external object has a size, it is expected it represents an array-like structure.
Note that even if an e.g. java ArrayList has a "size", the returned value still would be false, because it will be recognised as an array-like structure.}
\usage{
is.external.array(obj)
}
\arguments{
\item{obj}{an external object}
}
\value{
TRUE in case the given value is an array-like structure, otherwise FALSE.
}
\description{
Determines whether the given external object has a size. If an external object has a size, it is expected it represents an array-like structure.
Note that even if an e.g. java ArrayList has a "size", the returned value still would be false, because it will be recognised as an array-like structure.
}
\examples{
javaClass <- new.java.class('java.util.ArrayList')
is.external.array(javaClass)
}
\seealso{
\code{\link{new.java.array}}, \code{\link{as.java.array}}
}
